package controlador;

import curso.model.Curso;
import estudoCaso.cadastro.CadastroEstudoCaso;
import estudoCaso.model.EstudoCaso;
import estudoCaso.model.IEstudoCaso;
import usuario.model.IUsuario;

public class ControladorEstudoCaso {

	private static ControladorEstudoCaso instancia;
	private CadastroEstudoCaso cadastroEstudoCaso;

	private ControladorEstudoCaso() {
		cadastroEstudoCaso = new CadastroEstudoCaso();
	}

	public static ControladorEstudoCaso getInstancia(){

		if(instancia == null){

			instancia = new ControladorEstudoCaso();

		}

		return instancia;
	}

	public boolean cadastrarEstudoCaso(IUsuario usuario, int id, Curso curso, byte[] imagem, String descricao,
			int grauDificuldade, String nome){

		boolean sucesso = false;

		IEstudoCaso estudo = cadastroEstudoCaso.getEstudoCasoNome(nome);

		if(estudo == null){

			estudo = new EstudoCaso();

			estudo.setBloqueado(true);
			estudo.setCurso(curso);
			estudo.setDescricao(descricao);
			estudo.setImagem(imagem);
			estudo.setGrauDificuldade(grauDificuldade);
			estudo.setNome(nome);

			cadastroEstudoCaso.cadastrarEstudoCaso(estudo);
		}

		return sucesso;
	}
}
