package estudoCaso.model;

import static javax.persistence.GenerationType.IDENTITY;

import javax.persistence.Column;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import curso.model.Curso;

public interface IEstudoCaso {

	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "id", unique = true, nullable = false)
	public abstract int getId();

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "curso_id", nullable = false)
	public abstract Curso getCurso();

	public abstract void setCurso(Curso curso);

	@Column(name = "imagem", nullable = true)
	public abstract byte[] getImagem();

	public abstract void setImagem(byte[] imagem);

	@Column(name = "descricao", nullable = false, length = 500)
	public abstract String getDescricao();

	public abstract void setDescricao(String descricao);

	@Column(name = "grauDificuldade", nullable = false)
	public abstract int getGrauDificuldade();

	public abstract void setGrauDificuldade(int grauDificuldade);

	@Column(name = "nome", nullable = false, length = 200)
	public abstract String getNome();

	public abstract void setNome(String nome);

	@Column(name = "bloqueado", nullable = false)
	public abstract boolean isBloqueado();

	public abstract void setBloqueado(boolean bloqueado);

}