package estudoCaso.repositorio;

import estudoCaso.model.EstudoCaso;
import estudoCaso.model.IEstudoCaso;
import genericos.HibernateUtil;

import org.hibernate.Session;
import org.hibernate.Transaction;

public class RepositorioEstudoCaso implements IRepositorioEstudoCaso {
	
	private Session sessao;

	{
		if (sessao == null) {

			sessao = HibernateUtil.getFabricaDeSessao().getCurrentSession();

		} else if (!sessao.isOpen()) {

			sessao = HibernateUtil.getFabricaDeSessao().openSession();
		}
	}
	
	private Session getSession(){
		if (sessao == null) {

			sessao = HibernateUtil.getFabricaDeSessao().getCurrentSession();

		} else if (!sessao.isOpen()) {

			sessao = HibernateUtil.getFabricaDeSessao().openSession();
		}
		
		return sessao;
	}
	
	public void abrirTransacao(){

		try{
			Transaction t = getSession().getTransaction();
			t.begin();
		}catch(Exception e){
			e.printStackTrace();
		}
	}

	public void fecharTransacao(){
		try{
			Transaction t = getSession().getTransaction();
			t.commit();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	/* (non-Javadoc)
	 * @see estudoCaso.repositorio.IRepositorioEstudoCaso#cadastrarEstudoCaso(estudoCaso.model.IEstudoCaso)
	 */
	@Override
	public boolean cadastrarEstudoCaso(IEstudoCaso estudo) {

		boolean retorno = false;
		
		abrirTransacao();
		
		sessao.saveOrUpdate(estudo);

		fecharTransacao();
		
		retorno = true;
		
		return retorno;
	}
	
	/* (non-Javadoc)
	 * @see estudoCaso.repositorio.IRepositorioEstudoCaso#getUsuarioNome(java.lang.String)
	 */
	@Override
	public IEstudoCaso getEstudoCasoNome(String nome) {

		IEstudoCaso retorno = null;
		
		abrirTransacao();
		retorno = (IEstudoCaso) sessao
				.createSQLQuery(
						"SELECT {u.*} FROM estudocaso u WHERE u.nome='" + nome
								+ "';").addEntity("u", EstudoCaso.class)
				.uniqueResult();

		fecharTransacao();
		
		
		return retorno;
	}

}
