package fachada;

import usuario.model.IUsuario;
import controlador.ControladorEstudoCaso;
import controlador.ControladorLogon;
import curso.model.Curso;

public class Fachada {
	
	private static Fachada instancia;
	private ControladorLogon controladorLogon;
	private ControladorEstudoCaso controladorEstudoCaso;
	
	private Fachada(){
		
		controladorLogon = ControladorLogon.getInstancia();
		
		controladorEstudoCaso = ControladorEstudoCaso.getInstancia();
		
	}
	
	public static Fachada getInstancia(){
		
		if(instancia == null){
			
			instancia = new Fachada();
		}
		
		return instancia;
	}

	public boolean logon(String login, String senha){
		
		boolean sucesso = false;
		
		sucesso = controladorLogon.logon(login, senha);
		
		return sucesso;
		
	}
	
	public boolean cadastrarEstudoCaso(IUsuario usuario, int id, Curso curso, 
			byte[] imagem, String descricao,
			int grauDificuldade, String nome){
		
		return controladorEstudoCaso.cadastrarEstudoCaso(usuario, id, curso, imagem, descricao, grauDificuldade, nome);
	}
}
