package factory;

import estudoCaso.repositorio.IRepositorioEstudoCaso;
import estudoCaso.repositorio.RepositorioEstudoCaso;
import usuario.repositorio.IRepositorioUsuario;
import usuario.repositorio.RepositorioUsuarioHibernate;

public class RepositorioFactory {
	@SuppressWarnings("unchecked")
	public static <T> T getRepositorio(Class<T> iRepositorio) throws ClassNotFoundException {
		if (iRepositorio.equals(IRepositorioUsuario.class)) {
			return (T) new RepositorioUsuarioHibernate();
		}else if (iRepositorio.equals(IRepositorioEstudoCaso.class)) {
			return (T) new RepositorioEstudoCaso();
		}
		return null;
	}
}
