package usuario.model;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

import curso.model.Curso;

@Entity
@Table(name = "usuario", catalog = "pensae", uniqueConstraints = {
		@UniqueConstraint(columnNames = "login"),
		@UniqueConstraint(columnNames = "email") })
public class Usuario implements Serializable, IUsuario{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -4086155743819364331L;
	private int id;
	private String login;
	private String senha;
	private String nome;
	private String email;
	private String instituicao;
	private int papel;
	
	public Usuario(){
		
	}
	
	
	
	public Usuario(int id, String login, String senha, String nome,
			String email, String instituicao, int papel) {
		super();
		this.id = id;
		this.login = login;
		this.senha = senha;
		this.nome = nome;
		this.email = email;
		this.instituicao = instituicao;
		this.papel = papel;
	}



	public Usuario(String login, String senha) {
		this.login = login;
		this.senha = senha;
	}
	
	public Usuario(String login, String senha, int id) {
		this.login = login;
		this.senha = senha;
		this.id = id;
	}
	
	public void setId(int id) {
		this.id = id;
	}

	public void setLogin(String login) {
		this.login = login;
	}

	/* (non-Javadoc)
	 * @see usuario.model.IUsuario#setSenha(java.lang.String)
	 */
	@Override
	public void setSenha(String senha) {
		this.senha = senha;
	}
	
	/* (non-Javadoc)
	 * @see usuario.model.IUsuario#getId()
	 */
	@Override
	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "id", unique = true, nullable = false)
	public int getId() {
		return id;
	}

	
	/* (non-Javadoc)
	 * @see usuario.model.IUsuario#getLogin()
	 */
	@Override
	@Column(name = "login", unique = true, nullable = false, length = 50)
	public String getLogin() {
		return login;
	}
	/* (non-Javadoc)
	 * @see usuario.model.IUsuario#getSenha()
	 */
	@Override
	public String getSenha() {
		return senha;
	}

	/* (non-Javadoc)
	 * @see usuario.model.IUsuario#getEmail()
	 */
	@Override
	public String getEmail() {
		return email;
	}

	/* (non-Javadoc)
	 * @see usuario.model.IUsuario#setEmail(java.lang.String)
	 */
	@Override
	public void setEmail(String email) {
		this.email = email;
	}

	/* (non-Javadoc)
	 * @see usuario.model.IUsuario#getInstituicao()
	 */
	@Override
	public String getInstituicao() {
		return instituicao;
	}

	/* (non-Javadoc)
	 * @see usuario.model.IUsuario#setInstituicao(java.lang.String)
	 */
	@Override
	public void setInstituicao(String instituicao) {
		this.instituicao = instituicao;
	}

	/* (non-Javadoc)
	 * @see usuario.model.IUsuario#getPapel()
	 */
	@Override
	public int getPapel() {
		return papel;
	}

	/* (non-Javadoc)
	 * @see usuario.model.IUsuario#setPapel(int)
	 */
	public void setPapel(int papel) {
		this.papel = papel;
	}
	/* (non-Javadoc)
	 * @see usuario.model.IUsuario#getNome()
	 */
	@Override
	public String getNome() {
		return nome;
	}

	/* (non-Javadoc)
	 * @see usuario.model.IUsuario#setNome(java.lang.String)
	 */
	@Override
	public void setNome(String nome) {
		this.nome = nome;
	}
}
